# NOTICE:
#
# Application name defined in TARGET has a corresponding QML filename.
# If name defined in TARGET is changed, the following needs to be done
# to match new name:
#   - corresponding QML filename must be changed
#   - desktop icon filename must be changed
#   - desktop filename must be changed
#   - icon definition filename in desktop file must be changed
#   - translation filenames have to be changed

# The name of your application
TARGET = harbour-labyrinth

CONFIG += sailfishapp

# App version
DEFINES += APP_VERSION=\"\\\"$${VERSION}\\\"\"

SOURCES += src/harbour-labyrinth.cpp

OTHER_FILES += qml/harbour-labyrinth.qml \
    qml/cover/CoverPage.qml \
    rpm/harbour-labyrinth.changes.in \
    rpm/harbour-labyrinth.spec \
    rpm/harbour-labyrinth.yaml \
    translations/*.ts \
    harbour-labyrinth.desktop

SAILFISHAPP_ICONS = 86x86 108x108 128x128 256x256

# to disable building translations every time, comment out the
# following CONFIG line
CONFIG += sailfishapp_i18n

# German translation is enabled as an example. If you aren't
# planning to localize your app, remember to comment out the
# following TRANSLATIONS line. And also do not forget to
# modify the localized app name in the the .desktop file.
TRANSLATIONS += translations/harbour-labyrinth-de.ts

DISTFILES += \
    ../harbour-notes/qml/pages/OpenPage.qml \
    qml/pages/CastInfoPage.qml \
    qml/pages/CastPage.qml \
    qml/pages/Favorites.qml \
    qml/pages/InfoPage.qml \
    qml/pages/PopularPage.qml \
    qml/pages/SearchPage.qml \
    qml/pages/SeasonNrPage.qml \
    qml/pages/SeasonsPage.qml \
    qml/js/jsonpath.js \
    qml/js/favorites.js \
    qml/JSONListModel/JSONSimple.qml \
    qml/JSONListModel/JSONListModel.qml \
    qml/delegates/ShowDelegate.qml \
    qml/JSONListModel/JSONGetUpdated.qml \
    qml/pages/ShowImg.qml \
    qml/pages/WebViewer.qml
